﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;


namespace Mod
{
  public class AngelSword : MonoBehaviour
  {
    public bool active = false;
    public GameObject sword;

    public IEnumerator Regen() 
        {
          foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          Limbs.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("REGENJUICE"), 1f);
                        }
                        yield return new WaitForSeconds(10f);
                        StartCoroutine(Regen());
        }

        public void Start()
        {
          StartCoroutine(Regen());
        }

    public void Use()
    { 
      if (!active)
      {
        active = true;
        sword = GameObject.Instantiate(ModAPI.FindSpawnable("Sword").Prefab);
        sword.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.adsword;
        sword.gameObject.FixColliders();
        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.up, 0f, 1.1f, true, false),
                            new SharpAxis(Vector2.right, 0f, 1.1f, true, false),
                        };

        sword.GetComponent<PhysicalBehaviour>().Properties = properties;
        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
        var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = sword.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
        sword.transform.position = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
        sword.transform.rotation = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation;
        sword.transform.eulerAngles += new Vector3(0, 0, 180);
        sword.gameObject.AddComponent<drain>();
        sword.gameObject.AddComponent<HingeJoint2D>();
        sword.gameObject.GetComponent<HingeJoint2D>().connectedBody = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.GetComponent<Rigidbody2D>();
        var e = ModAPI.CreateParticleEffect("Disintegration", sword.gameObject.transform.position);
                e.GetComponent<ParticleSystem>().startColor = new Color(150f, 0f, 120f);
      }
      else
      {
        var e = ModAPI.CreateParticleEffect("Disintegration", sword.gameObject.transform.position);
                e.GetComponent<ParticleSystem>().startColor = new Color(150f, 0f, 120f);
        active = false;
        Destroy(sword.gameObject);
        sword = null;
      }
    }
  }
    public class drain : MonoBehaviour
    {
      public GameObject g;

      public void OnCollisionExit2D(Collision2D other)
        {
          g = null;
        }

        public void Update()
        {
          if (g != null)
          {
            g.gameObject.GetComponent<LimbBehaviour>().Health -= 1f;
            g.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.0006f;
          }
        }

      public void OnCollisionEnter2D(Collision2D other)
        {
          if (other.gameObject.layer == 9 && other.gameObject.GetComponent<LimbBehaviour>())
          {
            g = other.gameObject;
          }
        }

    }
}