﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;


namespace Mod
{
    public class kon : MonoBehaviour
    {
      public GameObject Hand;
      public GameObject Fox;
      public bool active = false;
      public AudioClip say = Mod.konsay;
        public AudioSource audioSource;
        public bool f = true;
        public Texture2D trail = Mod.trail;


      public void Start()
      {
        Hand = new GameObject("Hand");
        //Hand.transform.SetParent(transform);
        Hand.gameObject.AddComponent<SpriteRenderer>();
        Hand.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        Hand.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.kon;
        Hand.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
        audioSource = new GameObject().gameObject.AddComponent<AudioSource>();
    audioSource.transform.SetParent(Hand.transform, false);
    GameObject.FindObjectOfType<Global>().AddAudioSource(audioSource,false);
    audioSource.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.75f;
    audioSource.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
    audioSource.spatialBlend = 1;
    audioSource.volume = 1;
      }

      public void Use()
      {
        if (!active)
        {
          active = true;
          Hand.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
        }
      }

      public IEnumerator FoxEat() 
        {
          f = false;
          audioSource.PlayOneShot(say);
          yield return new WaitForSeconds(1f);
        Hand.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
          Fox = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
        Fox.transform.SetParent(transform);
        Fox.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        Fox.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.fox;
        Fox.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
        Fox.gameObject.GetComponent<PhysicalBehaviour>().InitialMass = float.PositiveInfinity;;
        Fox.gameObject.GetComponent<PhysicalBehaviour>().TrueInitialMass = float.PositiveInfinity;
        Fox.FixColliders();
        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
        var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = Fox.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
        Fox.AddComponent<OMNOMNOM>();
        var trailrenderer = Fox.gameObject.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 6f;
        trailrenderer.endWidth = 6f;
        trailrenderer.time = 1f;
        trailrenderer.startColor = new Color32(255, 255, 255, 20);
        trailrenderer.endColor = new Color32(255, 255, 255, 10);
        Material mat = new Material(ModAPI.FindMaterial("Sprites-Default"));
        mat.SetTexture("_MainTex", trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder -= 4;
        Fox.transform.position = Hand.transform.position;
        Fox.transform.eulerAngles = new Vector3(0, 0, 0);
        var gg5 = ModAPI.CreateParticleEffect("PinkExplosion", Fox.transform.position);
  gg5.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0f);
        Fox.gameObject.GetComponent<Rigidbody2D>().AddForce(-Fox.transform.right * 7f, ForceMode2D.Impulse);
        yield return new WaitForSeconds(10f);
        var gg15 = ModAPI.CreateParticleEffect("PinkExplosion", Fox.transform.position);
  gg15.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0f);
            active = false;
            Destroy(Fox);
            f = true;
        }
      

      public void Update()
      {
        if (f)
        {
        Vector3 mousePosition = Camera.main.ScreenToWorldPoint(Input.mousePosition);
        mousePosition.z = Camera.main.transform.position.z + Camera.main.nearClipPlane;
        Hand.transform.position = mousePosition;
        }
        else
        {
          CameraShakeBehaviour.main.Shake(1f * 5f, Hand.transform.position);
        }
        Hand.transform.eulerAngles = new Vector3(0, 0, 0);

        if (active)
        {
          if(Input.GetKeyUp(KeyCode.F))
          {
            active = false;
            StartCoroutine(FoxEat());
          }
        }

      }
    }
    public class OMNOMNOM : MonoBehaviour
    {
      public void OnCollisionEnter2D(Collision2D other)
        {
          if (other.gameObject.layer == 9)
          {
            other.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
            var gg15 = ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
            gg15.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0f);
          }
        }
    }
    public class snake : MonoBehaviour
    {
      public GameObject Hand;
      public GameObject Fox;
      public bool active = false;
      public AudioClip say = Mod.leave;
        public AudioSource audioSource;
        public bool f = true;
        public Texture2D trail = Mod.snake;


      public void Start()
      {
        Hand = new GameObject("Hand");
        //Hand.transform.SetParent(transform);
        Hand.gameObject.AddComponent<SpriteRenderer>();
        Hand.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        Hand.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.kon;
        Hand.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
        audioSource = new GameObject().gameObject.AddComponent<AudioSource>();
    audioSource.transform.SetParent(transform, false);
    GameObject.FindObjectOfType<Global>().AddAudioSource(audioSource,false);
    audioSource.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.75f;
    audioSource.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
    audioSource.spatialBlend = 1;
    audioSource.volume = 1;
      }

      public void Use()
      {
        if (!active)
        {
          active = true;
          StartCoroutine(FoxEat());
        }
        else
        {
          var gg15 = ModAPI.CreateParticleEffect("PinkExplosion", Fox.transform.position);
  gg15.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0f);
            active = false;
            audioSource.PlayOneShot(say);
            Destroy(Fox);
            f = true;
        }
      }

      public IEnumerator FoxEat() 
        {
          f = false;
          Fox = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
        Fox.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        Fox.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.snake2;
        Fox.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
        //Fox.gameObject.GetComponent<PhysicalBehaviour>().InitialMass = float.PositiveInfinity;;
        //Fox.gameObject.GetComponent<PhysicalBehaviour>().TrueInitialMass = float.PositiveInfinity;
        Fox.FixColliders();
        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
        var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = Fox.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
        Fox.AddComponent<OMNOMNOM>();
        var trailrenderer = Fox.gameObject.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 6.4f;
        trailrenderer.endWidth = 6.4f;
        trailrenderer.time = 10f;
        trailrenderer.startColor = new Color32(255, 255, 255, 255);
        trailrenderer.endColor = new Color32(255, 255, 255, 255);
        Material mat = new Material(ModAPI.FindMaterial("Sprites-Default"));
        mat.SetTexture("_MainTex", trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder -= 4;
        Fox.transform.rotation = transform.rotation;
                    Fox.transform.position = transform.position + (-transform.up * 0.5f);
                    Fox.GetComponent<Rigidbody2D>().AddRelativeForce(-Fox.transform.up * 623);
        var gg5 = ModAPI.CreateParticleEffect("PinkExplosion", Fox.transform.position);
  gg5.GetComponent<ParticleSystem>().startColor = new Color(1f, 1f, 1f);
  yield return new WaitForSeconds(1f);
      }
    }
}